
package net.javainthebox.flickrviewer;
 
import javafx.scene.CustomNode;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.effect.DropShadow;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
 
public class Thumbnail extends CustomNode {
    // IꂽɃR[R[obN֐
    public var action: function(thumbnail: Thumbnail): Void;
 
    // C[W̃^Cg
    public var title: String;

    // TlCC[W URL
    // URLύXAC[W[h
    public var thumbnailUrl: String on replace {
        if (thumbnailUrl != null) {
            thumbnail = Image {
                url: thumbnailUrl
            }
        }
    }
        
    // TlCC[W
    var thumbnail: Image;

    // C[WURL
    public var imageUrl: String;

    public-read def width: Number = 110.0;
    public-read def height: Number = 110.0;

    // IԂ\tO
    public var selected: Boolean = false;
    // NbNꂽIԂƂAR[obN֐R[
    override var pressed on replace {
        if (not selected and pressed) {
            selected = true;
            action(this);
        }
    }
 
    public override function create(): Node {
        Group {
            content: [
                Rectangle {
                    // pێlpɂ
                    arcHeight: 10
                    arcWidth: 10
                    x: 0
                    y: 0
                    width: 109
                    height: 109
                    // IԂł̓O[AIԂł͍
                    fill: bind if (selected) Color.web("#666666") else  Color.web("#222222")
                    stroke: Color.web("#666666")
                    // hbvVhE{Ƃɂ蕂ł悤Ȍʂo
                    effect: DropShadow {
                        offsetX: 1
                        offsetY: 1
                        radius: 1
                        color: Color.LIGHTGRAY
                    }
                },
                ImageView {
                    // C[W͒ɔzu
                    x: bind (width - thumbnail.width)/2
                    y: bind (height - thumbnail.height)/2
                    image: bind thumbnail
                }
            ]
        }
    }
}