
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import javafx.ext.swing.SwingList;
import javafx.ext.swing.SwingListItem;
import javafx.ext.swing.SwingScrollPane;
import javafx.io.http.HttpRequest;
import javafx.scene.Scene;
import javafx.stage.Stage;
import javafx.stage.StageStyle;

var items: SwingListItem[];

Stage {
    style: StageStyle.UNDECORATED
    scene: Scene {
        width: 600
        height: 600
        content: [
            SwingScrollPane {
                width: 600
                height: 600
                view: SwingList {
                    items: bind items
                }
            }
        ]
    }
}

var request = HttpRequest {
    location: "http://javainthebox.net/temp/httprequestsample.html"

    onInput: function(stream: InputStream) {
        var reader = new BufferedReader(
            new InputStreamReader(stream));

        while(true) {
            var text = reader.readLine();
            if (text == null) {
                break;
            }
            var item = SwingListItem {
                text: text
            }
            insert item into items;
        }

        stream.close();
    }
}
request.enqueue();

